<?php

namespace Drupal\prevent_extend\EventSubscriber;

use Symfony\Component\HttpKernel\KernelEvents;
use Symfony\Component\HttpKernel\Event\GetResponseEvent;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;

class PreventExtendSubscriber implements EventSubscriberInterface {

  /**
   * {@inheritdoc}
   */
  public function checkForModuleInstallUninstall(GetResponseEvent $event) {
    $request = $event->getRequest();
    if ($request->attributes->get('_route') == 'update.module_install' || $request->attributes->get('_route') == 'system.modules_uninstall' || $request->attributes->get('_route') == 'update.module_update' || $request->attributes->get('_route') == 'system.modules_list') {
      throw new \Symfony\Component\HttpKernel\Exception\AccessDeniedHttpException();
    }
  }

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents(): array
  {
    $events[KernelEvents::REQUEST][] = ['checkForModuleInstallUninstall'];
    return $events;
  }

}
